<style media="screen" type="text/css">
    /*@#page-include#(commonMine.css)*/
</style>

<p id="introText">
    Na ovoj stranici pogledat ćemo i osnovna brojila.
</p>


<div class="basicText">
    U digitalnom svijetu postoje razna brojila. Brojila prije svega &ndash; broje. Brojanje možemo ostvariti u
    proizvoljno bazi, ipak, najčešće ćemo se susresti s binarnim brojilima.
    <br><br>
    Brojila možemo podijeliti na sinkrona (engl. <i>synchronous</i>) i asinkrona (engl. <i>asynchronous</i>). Na ovoj
    stranici razmatrat ćemo asinkrona brojila.
</div>
<hr>
<div class="header">
    Asinkrona binarna brojila
</div>


<p class="basicText">
    Na simulaciji u nastavku možemo vidjeti jedan primjer asinkronog brojila. Inicijalno je prikazana implementacija
    brojila,
    ali se to lako promijeni na jednak način na koji ste to radili na prethodnim simulacijama.

    Interna implementacija ovog brojila bit će nam potrebna kako bi objasnili na koji način ovo brojilo radi i koje su
    karakteristike ovog brojila.
    Specifikacije ove simulacije su sljedeće:
</p>

<ul class="listStyle">
    <li>Brojilo broji padajuće bridove signala takta.</li>
    <li>Lijevo ispod brojila nalazi se klikabilna kućica kojom možete mijenjati broj trenutno prikazanih bistabila.</li>
    <li>Desno ispod brojila nalazi se klikabilna kućica kojom možete mijenjati kašnjenje bistabila.</li>
    <li>Dekoder pokazuje trenutno stanje izlaza brojila.</li>
</ul>

<p class="basicText">
    Za početak ćemo pogledati samo ožičenje ovog brojila. Krenimo s tipom bistabila. Vidimo da je ovo brojilo
    implementirano bistabilom T, odnosno da su svi bistabili od kojeg se brojilo sastoji upravo bistabili T. Gledajući s
    lijeva na desno, prvom smo bistabilu spojili vanjski signal takta (odnosno na njega dovodimo impulse koje brojilo
    broji). Na ulaz tog bistabila dovedena je logička
    jedinica (ulaz T je fiksno spojen na 1). <br><br>
    Promotrimo i ostale bistabile, drugi bistabil nije povezan s vanjskim signalom takta već je na njegov ulaz za signal
    takta doveden izlaz prethodnog bistabila, tj. \(Q_0\). Uočimo da su svi ulazi T T-bistabila spojeni fiksno na
    logičku jedinicu. Ovakvo povezivanje ima za posljedicu da će bistabili T na svaki padajući brid signala
    takta promijeniti stanje. Ovdje moramo biti malo specifičniji od toga, zato što sada nemamo jedan signal takta. U
    inicijalnoj konfiguraciji od 4 bistabila T imat ćemo 4 različita signala takta, gdje pod različitim mislimo da ne
    djeluju u isto vrijeme, točnije ne djeluju sinkrono (otuda i naziv asinkronog brojila). Signali takta koje
    generiramo za ovo brojilo s 4 bistabila su:

</p>

<ul class="listStyle">
    <li>Vanjski signal takta kojim upravlja korisnik simulacije.</li>
    <li>Signal takta \(Q_0\) koji ima duplo manju frekvenciju od vanjskog signala takta.</li>
    <li>Signal takta \(Q_1\) koji ima duplo manju frekvenciju od \(Q_0\).</li>
    <li>Signal takta \(Q_2\) koji ima duplo manju frekvenciju od \(Q_1\).</li>
</ul>

<hr>
<div align="center">
    <canvas id="asyncCounter" width="900" height="500"></canvas>
</div>
<hr>

<p class="basicText">
    Nakon što smo vidjeli osnovna svojstva ove simulacije, idemo ju isprobati.
    Pretpostavljajući da niste mijenjali broj bistabila niti dodavali kašnjenje, isprobajte sljedeće.
    Napravite jedan ciklus s ovim brojilom. Drugim riječima, generirajte padajuće bridove signala takta toliko dugo dok
    brojilo ne dođe u ono stanje u kojem je i bilo. Jedan takav ciklus možemo konstruirati od skupa stanja
    {<code>0000</code>
    ... <code>1111</code>} nakon čega će brojilo ponovo prijeći u stanje 0. Bez dodavanja kašnjenja ovo će brojilo na
    svaki padajući brid signala takta mijenjati stanje po prirodnom binarnom kodu (odnosno svim kombinacijama 4 bita,
    redom <code>0000, 0001, 0010, 0011, 0100, ..., 1111, 0000</code>).
</p>


<p class="basicText">
    Jeste li uočili na koji način brojilo broji?
    Evo i zornijeg primjera. Promotrite sljedeću tablicu istinitosti.
</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 1.</span> Tablica kombinacija za 4 bita.</div>
<div align="center">
    <table class="mlTableCC">
        <tr>
            <th>\(Q_3\)</th>
            <th>\(Q_2\)</th>
            <th>\(Q_1\)</th>
            <th>\(Q_0\)</th>
        </tr>
        <tr>
            <td>0</td>
            <td>0</td>
            <td>0</td>
            <td>0</td>
        </tr>
        <tr>
            <td>0</td>
            <td>0</td>
            <td>0</td>
            <td>1</td>
        </tr>
        <tr>
            <td>0</td>
            <td>0</td>
            <td>1</td>
            <td>0</td>
        </tr>
        <tr>
            <td>0</td>
            <td>0</td>
            <td>1</td>
            <td>1</td>
        </tr>
        <tr>
            <td>0</td>
            <td>1</td>
            <td>0</td>
            <td>0</td>
        </tr>
        <tr>
            <td>0</td>
            <td>1</td>
            <td>0</td>
            <td>1</td>
        </tr>
        <tr>
            <td>0</td>
            <td>1</td>
            <td>1</td>
            <td>0</td>
        </tr>
        <tr>
            <td>0</td>
            <td>1</td>
            <td>1</td>
            <td>1</td>
        </tr>
        <tr>
            <td>1</td>
            <td>0</td>
            <td>0</td>
            <td>0</td>
        </tr>
        <tr>
            <td>1</td>
            <td>0</td>
            <td>0</td>
            <td>1</td>
        </tr>
        <tr>
            <td>1</td>
            <td>0</td>
            <td>1</td>
            <td>0</td>
        </tr>
        <tr>
            <td>1</td>
            <td>0</td>
            <td>1</td>
            <td>1</td>
        </tr>
        <tr>
            <td>1</td>
            <td>1</td>
            <td>0</td>
            <td>0</td>
        </tr>
        <tr>
            <td>1</td>
            <td>1</td>
            <td>0</td>
            <td>1</td>
        </tr>
        <tr>
            <td>1</td>
            <td>1</td>
            <td>1</td>
            <td>0</td>
        </tr>
        <tr>
            <td>1</td>
            <td>1</td>
            <td>1</td>
            <td>1</td>
        </tr>
    </table>
</div>

<p class="basicText">
    U prethodnoj tablici razmotrit ćemo najprije frekvenciju nula i jedinica za pojedine izlaze. Tako na primjer, izlaz
    najveće
    težine \(Q_3\) poprima vrijednost 1 tek nakon 8 koraka. Nakon njega, izlaz \(Q_2\) mijenja stanje iz 0 u 1 nakon
    duplo manje
    koraka, točnije svaka 4. Slično vrijedi i za preostala dva ulaza, ulaz \(Q_1\) mijenja se svakih 2 koraka i \(Q_0\)
    mijenja svoju vrijednost svaki sljedeći korak. Gledajući ponovo naše asinkrono binarno brojilo, uočimo da radi
    upravo na opisani način. Odnosno da se izlazi brojila mijenjaju po danoj tablici istinitosti. Ovo brojilo promijenit
    će stanje bita veće težine nakon što su svi prethodni bitovi bili u jedinici.
</p>

<p class="basicText">
    Ako ste isprobali prethodnu simulaciju mogli ste uočiti da se brojilo može zateći u raznim stanjima koja nisu dio
    ciklusa. Tako na primjer prilikom prijelaza brojila iz stanja <code>0111</code> u stanje <code>1000</code>; imat
    ćemo sljedeća prijelazna stanja: <code>0110, 0100 i 0000</code>. Ovakva stanja koja nisu dio ciklusa a posljedica su
    načina izvedbe brojila zovemo <i>tranzijentna stanja</i>.
</p>

<hr>
<p class="basicText">
    Kako bismo ljepše vidjeli tranzijenta stanja asinkronih brojila dodat ćemo im kašnjenje. Na sljedećoj simulaciji
    nalazi se jedno asinkrono binarno brojilo. Ovo brojilo izvedeno je na malo drugačiji način, a posljedica toga je da
    broji unatrag. Točnije, ciklus ovog brojila bit će: <code>0000 -> 1111 -> 1110 -> 1101 ... 0001 -> 0000</code>.
    Tranzijentna stanja možete isprobati na ovoj ili prethodnoj simulaciji, po izboru.
</p>


<hr>

<div class="basicText">
    Pa krenimo. Na izabranoj simulaciji postavite kašnjenje bistabila na 1 ili 2 sekunde (1000 ili 2000 milisekunde)
    kako bi što jednostavnije pratili promjene (kašnjenje na određenu vrijednost postavite klikanjem kućice koja se
    nalazi desno ispod brojila). Probajte sada generirati padajuće bridove signala takta i pratite stanja izlaza (stanje
    najjednostavnije možete pratiti čitajući dekoder). U trenutcima kada brojilo računa sljedeće stanje i prolazi kroz
    tranzijentna stanja (ako takva postoje) bit će vam onemogućeno postavljanje novog signala takta (kao i dodavanje
    bistabila te mijenjanje kašnjenja) te naznačeno crvenkastim obrubom što se točno na simulaciji mijenja. Drugim
    riječima koji bistabil je trenutno aktivan (pobuđen padajućim bridom) i mijenja svoje stanje.
</div>

<hr>
<div align="center">
    <canvas id="asyncCounterReverse" width="900" height="500"></canvas>
</div>
<hr>

<p class="basicText">
    Sada ćemo definirati i vrijeme kašnjenja ovakvog sklopa. Pretpostavimo li da se brojilo sastoji od 4 bistabila te da
    je vrijeme kašnjenja pojedinog bistabila 1 sekunda, možemo zaključiti da je najgori slučaj upravo onda kada moramo
    čekati sve prethodne bistabila da promjene stanje. Za 4 bita to je promjena iz stanja <code>0111 -> 1000</code> ili
    <code>1111 -> 0000</code>. Tada je kašnjenje ovog brojila:
    $$ T_d = 4 \cdot t_{db} = 4 \hskip 2mm sekunde $$

    Općenitije za asinkrono <i>n</i>&ndash;bitno binarno brojilo s prethodnih simulacija vrijedilo bi:
    $$ T_d = n \cdot t_{db} \hskip 2mm $$
</p>
<p class="basicText">
    Nadalje možemo definirati i maksimalnu frekvenciju kojom ovakav sklop može raditi. Drugim riječima, definirat ćemo
    koliko brzo smijemo postavljati novi padajući brid signala takta, a da pritom ne izgubimo prethodno stanje brojila.
    Iz tog razloga dodati ćemo i vrijeme očitanja. Vrijeme očitanja je vrijeme koje je potrebno da pročitamo dekodirano
    stanje izlaza. Kako maksimalnu frekvenciju rada definirano za najgori slučaj kašnjenja sklopa, time ćemo trebati
    pričekati vrijeme kašnjenja brojila i vrijeme očitanja. Sakupimo li sve prethodno dobivamo sljedeći izraz:
</p>

$$f_{max} = \frac{1} {n \cdot t_{db} + t_{očitanja}}$$

<p class="basicText">
    Dakle, maksimalna frekvencija rada ovog sklopa obrnuto je proporcionalna vremenima kašnjenja bistabila i vremenu
    očitanja izlaza.
</p>

<p id="outroText">
    Na sljedećoj stranici pogledat ćemo i kako su izvedena sinkrona brojila, te po čemu se razlikuju od asinkronih
    brojila.
</p>


<script>
    /*@#page-include#(library.js)*/
    /*@#page-include#(asyncCounter.js)*/
    /*@#page-include#(asyncCounterReverse.js)*/
</script>